package com.bonus.material.settlement.mapper;

import java.util.List;

import com.bonus.common.biz.domain.ProjectTreeNode;
import com.bonus.common.biz.domain.lease.LeaseOutDetails;
import com.bonus.material.common.domain.vo.AgreementVo;
import com.bonus.material.ma.domain.Type;
import com.bonus.material.repair.domain.RepairApplyDetails;
import com.bonus.material.settlement.domain.SltAgreementApply;
import com.bonus.material.settlement.domain.SltAgreementInfo;
import com.bonus.material.settlement.domain.SltAgreementRelation;
import com.bonus.material.settlement.domain.vo.SltInfoVo;
import com.bonus.material.settlement.domain.dto.PeriodCostQueryDto;
import com.bonus.material.settlement.domain.vo.PeriodCostResultVo;
import com.bonus.material.task.domain.TmTask;
import org.apache.ibatis.annotations.Param;

/**
 * 结算信息Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface SltAgreementInfoMapper {
    /**
     * 查询结算信息
     * 
     * @param id 结算信息主键
     * @return 结算信息
     */
    public SltAgreementInfo selectSltAgreementInfoById(Long id);

    /**
     * 查询【待审核】+【审核通过】的结算单数量
     * @param sltType 1：工器具结算单  2：安全工器具结算单
     * @param agreementId 协议id
     * @return 条数
     */
    int selectTheSettledCountByAgreementIdType(@Param("sltType") Integer sltType, @Param("agreementId") Long agreementId);

    /**
     * 查询结算信息列表
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结算信息集合
     */
    public List<SltAgreementInfo> selectSltAgreementInfoList(SltAgreementInfo sltAgreementInfo);

    /**
     * 新增结算信息
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结果
     */
    public int insertSltAgreementInfo(SltAgreementInfo sltAgreementInfo);

    /**
     * 修改结算信息
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结果
     */
    public int updateSltAgreementInfo(SltAgreementInfo sltAgreementInfo);

    /**
     * 删除结算信息
     * 
     * @param id 结算信息主键
     * @return 结果
     */
    public int deleteSltAgreementInfoById(Long id);

    /**
     * 批量删除结算信息
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSltAgreementInfoByIds(Long[] ids);

    SltAgreementInfo getSltAgreementInfo(LeaseOutDetails record);

    List<SltAgreementInfo> getSltAgreementInfo4Project(SltAgreementInfo record);

    List<SltAgreementApply> getSltExam(SltAgreementInfo bean);

    String getCost(SltAgreementApply apply);

    List<SltAgreementRelation> getRelations(SltAgreementApply apply);

    int updSltInfo(SltAgreementInfo sltAgreementInfo);

    int insSltInfo(@Param("record") LeaseOutDetails record, @Param("agreementId")String agreementId, @Param("ma") Type ma);

    // 查询一个协议号的领料详情
    List<SltAgreementInfo> getLeaseList(SltAgreementInfo bean);

    // 查询多个协议号的领料详情
    List<SltAgreementInfo> getLeaseListBatch(SltAgreementInfo bean);

    // 查询一个协议号的维修详情（根据taskIds）
    List<SltAgreementInfo> getRepairDetailsList(@Param("info") SltAgreementInfo info, @Param("taskList") List<TmTask> taskList);

    // 查询多个协议号的维修详情
    List<SltAgreementInfo> getRepairDetailsListBatch(@Param("info") SltAgreementInfo info, @Param("taskList") List<TmTask> taskList);

    // 查询一个协议号的报废详情（根据taskIds）
    List<SltAgreementInfo> getScrapDetailsList(@Param("info") SltAgreementInfo info, @Param("taskList") List<TmTask> taskList);

    // 查询多个协议号的报废详情
    List<SltAgreementInfo> getScrapDetailsListBatch(@Param("info") SltAgreementInfo info);

    // 获取一个协议号的丢失详情
    List<SltAgreementInfo> getLoseList(SltAgreementInfo bean);

    // 获取多个协议号的丢失详情
    List<SltAgreementInfo> getLoseListBatch(SltAgreementInfo bean);

    // 获取丢失报表
    List<SltAgreementInfo> getLostReportList(SltAgreementInfo bean);

    int updateRelation(SltAgreementApply apply);

    int updateApply(SltAgreementApply apply);

    int updateMaStatus(SltAgreementInfo agreementInfo);

    /**
     * 退料驳回结算信息处理
     */
    int backRejectSltCope(Long backTaskId);

    /**
     * 退料结算信息删除
     * @param leaseOutDetails
     * @return
     */
    int deleteSltInfo(@Param("record") LeaseOutDetails leaseOutDetails);

    /**
     * 查找是否驳回
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    public int getRejectCount(SltInfoVo sltInfoVo);

    /**
     * 获取已审核和待审核的条数
     * @param sltInfoVo 传入协议id
     * @return 结果 int条数
     */
    int getBeforeSettlementCount(SltInfoVo sltInfoVo);

    /**
     * 新增结算审核信息
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    public int insertSltAgreementApply(SltInfoVo sltInfoVo);

    /**
     * 修改结算审核信息
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    int updateBmAgreementStatus(SltInfoVo sltInfoVo);

    /**
     * 新增租赁结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailLease(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 新增维修结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailRepair(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 新增报废结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailScrap(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 新增丢失结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailLose(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 结算审批列表
     *
     * @param bean 结算信息
     * @return 结果
     */
    List<SltAgreementInfo> getSltList(SltAgreementInfo bean);

    /**
     * 已结算报表list查询
     */
    List<SltAgreementInfo> getSltReportedList(SltAgreementInfo bean);

    /**
     * 未结算报表查询
     * @param bean
     * @return
     */
    List<SltAgreementInfo> getSltReportList(SltAgreementInfo bean);

    /**
     * 未结算报表查询条数
     */
    int getSltReportListCount(SltAgreementInfo bean);

    /**
     * 对驳回的结算信息进行重新设置为未结算
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    int updateRejectCount(SltInfoVo sltInfoVo);

    /**
     * 获取对驳回的结算信息的id
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    Long getRejectId(SltInfoVo sltInfoVo);

    /**
     * 进行结算审批
     *
     * @param sltAgreementApply 进行结算审批
     * @return 结果
     */
    int costExame(SltAgreementApply sltAgreementApply);

    void costDeleteDetail(SltAgreementApply sltAgreementApply);

    /**
     * 审核驳回时修改是否结算
     *
     * @param sltAgreementApply 结算信息
     * @return 结果
     */
    int updateBmAgreementReject(SltAgreementApply sltAgreementApply);

    int[] getProjectListByUnitIds(int unitId);

    List<ProjectTreeNode> getProjectList(int projectId);

    List<AgreementVo> getAgreementInfoById(@Param("unitIds") List<Integer> unitIds, @Param("projectId") int projectId);

    int backInUseNum(RepairApplyDetails repairApplyDetails);

    /**
     * 获取结算信息
     * @param info
     * @return
     */
    List<SltAgreementInfo> getSltAgreementInfoById(SltAgreementInfo info);

    /**
     * 查询区间费用计算结果
     * @param queryDto 查询条件
     * @return 区间费用计算结果列表
     */
    List<PeriodCostResultVo> selectLeasePeriodCostList(PeriodCostQueryDto queryDto);

    /**
     * 查询区间费用计算结果 -- 已结算明细 -- 只查询租赁费用
     */
    List<PeriodCostResultVo> selectLeasePeriodCostListBySltDetails(PeriodCostQueryDto queryDto);

    /**
     * 查询区间费用-- 冲账记录表
     * @param queryDto 查询条件
     * @return 冲账记录
     */
    List<PeriodCostResultVo> selectPeriodCostListForCharge(PeriodCostQueryDto queryDto);
}
